diff --git a/contrib/amd/include/am_utils.h b/contrib/amd/include/am_utils.h
index 4098cd4..b7e55ce 100644
--- a/contrib/amd/include/am_utils.h
+++ b/contrib/amd/include/am_utils.h
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: am_utils.h,v 1.6 1999/08/22 05:12:55 ezk Exp $
+ * File: am-utils/include/am_utils.h
  *
  */
 
@@ -50,6 +49,8 @@
 #define _AM_UTILS_H
 
 
+#include "aux_conf.h"
+
 /**************************************************************************/
 /*** MACROS								***/
 /**************************************************************************/
@@ -76,16 +77,25 @@
 # ifdef HOSTNAMESZ
 #  define MAXHOSTNAMELEN HOSTNAMESZ
 # else /* not HOSTNAMESZ */
-#  define MAXHOSTNAMELEN 64
+#  define MAXHOSTNAMELEN 256
 # endif /* not HOSTNAMESZ */
 #endif /* not MAXHOSTNAMELEN */
 
 /*
+ * for hlfsd, and amd for detecting uid/gid
+ */
+#ifndef INVALIDID
+/* this is also defined in include/am_utils.h */
+# define INVALIDID	(((unsigned short) ~0) - 3)
+#endif /* not INVALIDID */
+
+/*
  * String comparison macros
  */
 #define STREQ(s1, s2)		(strcmp((s1), (s2)) == 0)
 #define STRCEQ(s1, s2)		(strcasecmp((s1), (s2)) == 0)
 #define NSTREQ(s1, s2, n)	(strncmp((s1), (s2), (n)) == 0)
+#define NSTRCEQ(s1, s2, n)	(strncasecmp((s1), (s2), (n)) == 0)
 #define FSTREQ(s1, s2)		((*(s1) == *(s2)) && STREQ((s1),(s2)))
 
 /*
@@ -102,16 +112,9 @@
 #define XLOG_DEFSTR	"all,nomap,nostats"	/* Default log options */
 #define XLOG_ALL	(XLOG_FATAL|XLOG_ERROR|XLOG_USER|XLOG_WARNING|XLOG_INFO|XLOG_MAP|XLOG_STATS)
 
-#define clocktime() (clock_valid ? clock_valid : time(&clock_valid))
-
-#ifndef ROOT_MAP
-# define ROOT_MAP "\"root\""
-#endif /* not ROOT_MAP */
-
-#define NO_SUBNET	"notknown"	/* default subnet name for no subnet */
-#define	NEXP_AP		(1022)	/* gdmr: was 254 */
-#define NEXP_AP_MARGIN	(128)
-#define	MAX_READDIR_ENTRIES	16
+#define NO_SUBNET	"notknown"   /* default subnet name for no subnet */
+#define	NEXP_AP		(1022)			/* gdmr: was 254 */
+#define NEXP_AP_MARGIN	(128)			/* ???? not used */
 
 /*
  * Linked list macros
@@ -126,84 +129,30 @@
 
 /* allocate anything of type ty */
 #define	ALLOC(ty)	((ty *) xmalloc(sizeof(ty)))
-#define	CALLOC(ty)	((ty *) xcalloc(1, sizeof(ty)))
+#define	CALLOC(ty)	((ty *) xzalloc(sizeof(ty)))
 /* simply allocate b bytes */
 #define	SALLOC(b)	xmalloc((b))
 
-/* converting am-filehandles to mount-points */
-#define	fh_to_mp2(fhp, rp) fh_to_mp3(fhp, rp, VLOOK_CREATE)
-
 /*
  * Systems which have the mount table in a file need to read it before
  * they can perform an unmount() system call.
  */
-#define UMOUNT_FS(dir, mtb_name)	umount_fs(dir, mtb_name)
-/* imported via $srcdir/conf/umount/umount_*.c */
-extern int umount_fs(char *fs_name, const char *mnttabname);
+#define UMOUNT_FS(dir, mtb_name, unmount_flags)	umount_fs(dir, mtb_name, unmount_flags)
+/* next two are imported via $srcdir/conf/umount/umount_*.c */
+extern int umount_fs(char *mntdir, const char *mnttabname, u_int unmount_flags);
+#ifdef MNT2_GEN_OPT_FORCE
+extern int umount2_fs(const char *mntdir, u_int unmount_flags);
+#endif /* MNT2_GEN_OPT_FORCE */
 
-/*
- * macros for automounter vfs/vnode operations.
- */
-#define	VLOOK_CREATE	0x1
-#define	VLOOK_DELETE	0x2
-#define FS_DIRECTORY	0x0001	/* This looks like a dir, not a link */
-#define	FS_MBACKGROUND	0x0002	/* Should background this mount */
-#define	FS_NOTIMEOUT	0x0004	/* Don't bother with timeouts */
-#define FS_MKMNT	0x0008	/* Need to make the mount point */
-#define FS_UBACKGROUND	0x0010	/* Unmount in background */
-#define	FS_BACKGROUND	(FS_MBACKGROUND|FS_UBACKGROUND)
-#define	FS_DISCARD	0x0020	/* Discard immediately on last reference */
-#define	FS_AMQINFO	0x0040	/* Amq is interested in this fs type */
-
-/*
- * macros for struct fserver.
- */
-#define	FSF_VALID	0x0001	/* Valid information available */
-#define	FSF_DOWN	0x0002	/* This fileserver is thought to be down */
-#define	FSF_ERROR	0x0004	/* Permanent error has occurred */
-#define	FSF_WANT	0x0008	/* Want a wakeup call */
-#define	FSF_PINGING	0x0010	/* Already doing pings */
-#define	FSRV_ISDOWN(fs)	(((fs)->fs_flags & (FSF_DOWN|FSF_VALID)) == (FSF_DOWN|FSF_VALID))
-#define	FSRV_ISUP(fs)	(((fs)->fs_flags & (FSF_DOWN|FSF_VALID)) == (FSF_VALID))
-
-/*
- * macros for struct mntfs (list of mounted filesystems)
- */
-#define	MFF_MOUNTED	0x0001	/* Node is mounted */
-#define	MFF_MOUNTING	0x0002	/* Mount is in progress */
-#define	MFF_UNMOUNTING	0x0004	/* Unmount is in progress */
-#define	MFF_RESTART	0x0008	/* Restarted node */
-#define MFF_MKMNT	0x0010	/* Delete this node's am_mount */
-#define	MFF_ERROR	0x0020	/* This node failed to mount */
-#define	MFF_LOGDOWN	0x0040	/* Logged that this mount is down */
-#define	MFF_RSTKEEP	0x0080	/* Don't timeout this filesystem - restarted */
-#define	MFF_WANTTIMO	0x0100	/* Need a timeout call when not busy */
-#ifdef HAVE_AM_FS_NFSL
-# define MFF_NFSLINK	0x0200	/* nfsl type, and deemed a link */
-#endif /* HAVE_AM_FS_NFSL */
-
-/*
- * macros for struct am_node (map of auto-mount points).
- */
-#define	AMF_NOTIMEOUT	0x0001	/* This node never times out */
-#define	AMF_ROOT	0x0002	/* This is a root node */
-#ifdef HAVE_FS_AUTOFS
-# define AMF_AUTOFS	0x0004	/* this node is of type autofs */
-#endif /* HAVE_FS_AUTOFS */
+/* unmount-related flags (special handling of autofs, forced/lazy, etc.) */
+#define AMU_UMOUNT_FORCE        0x1
+#define AMU_UMOUNT_DETACH       0x2
+#define AMU_UMOUNT_AUTOFS       0x4
 
 /*
  * The following values can be tuned...
  */
 #define	ALLOWED_MOUNT_TIME	40	/* 40s for a mount */
-#define	AM_TTL			(5 * 60)	/* Default cache period */
-#define	AM_TTL_W		(2 * 60)	/* Default unmount interval */
-#define	AM_PINGER		30 /* NFS ping interval for live systems */
-#define	AMFS_AUTO_TIMEO		8 /* Default amfs_auto timeout - .8s */
-
-/*
- * default amfs_auto retrans - 1/10th seconds
- */
-#define	AMFS_AUTO_RETRANS	((ALLOWED_MOUNT_TIME*10+5*gopt.amfs_auto_timeo)/gopt.amfs_auto_timeo * 2)
 
 /*
  * RPC-related macros.
@@ -211,6 +160,7 @@ extern int umount_fs(char *fs_name, const char *mnttabname);
 #define	RPC_XID_PORTMAP		0
 #define	RPC_XID_MOUNTD		1
 #define	RPC_XID_NFSPING		2
+#define	RPC_XID_WEBNFS		3
 #define	RPC_XID_MASK		(0x0f)	/* 16 id's for now */
 #define	MK_RPC_XID(type_id, uniq)	((type_id) | ((uniq) << 4))
 
@@ -221,20 +171,6 @@ extern int umount_fs(char *fs_name, const char *mnttabname);
  */
 #define	AMD_COMPAT	5000000	/* 5.0 */
 
-/*
- * Error to return if remote host is not available.
- * Try, in order, "host down", "host unreachable", "invalid argument".
- */
-#ifdef EHOSTDOWN
-# define AM_ERRNO_HOST_DOWN	EHOSTDOWN
-# else /* not EHOSTDOWN */
-# ifdef EHOSTUNREACH
-#  define AM_ERRNO_HOST_DOWN	EHOSTUNREACH
-# else /* not EHOSTUNREACH */
-#  define AM_ERRNO_HOST_DOWN	EINVAL
-# endif /* not EHOSTUNREACH */
-#endif /* not EHOSTDOWN */
-
 
 /**************************************************************************/
 /*** STRUCTURES AND TYPEDEFS						***/
@@ -242,13 +178,8 @@ extern int umount_fs(char *fs_name, const char *mnttabname);
 
 /* some typedefs must come first */
 typedef char *amq_string;
-typedef struct mntfs mntfs;
-typedef struct am_opts am_opts;
-typedef struct am_ops am_ops;
-typedef struct am_node am_node;
 typedef struct _qelem qelem;
 typedef struct mntlist mntlist;
-typedef struct fserver fserver;
 
 /*
  * Linked list
@@ -278,121 +209,6 @@ typedef enum {
   Done
 } serv_state;
 
-/*
- * Options
- */
-struct am_opts {
-  char *fs_glob;		/* Smashed copy of global options */
-  char *fs_local;		/* Expanded copy of local options */
-  char *fs_mtab;		/* Mount table entry */
-  /* Other options ... */
-  char *opt_dev;
-  char *opt_delay;
-  char *opt_dir;
-  char *opt_fs;
-  char *opt_group;
-  char *opt_mount;
-  char *opt_opts;
-  char *opt_remopts;
-  char *opt_pref;
-  char *opt_autopref;
-  char *opt_cache;
-  char *opt_rfs;
-  char *opt_rhost;
-  char *opt_sublink;
-  char *opt_type;
-  char *opt_unmount;
-  char *opt_user;
-  char *opt_maptype;		/* map type: file, nis, hesiod, etc. */
-  char *opt_cachedir;		/* cache directory */
-  char *opt_addopts;		/* options to add to opt_opts */
-};
-
-/*
- * List of mounted filesystems
- */
-struct mntfs {
-  qelem mf_q;			/* List of mounted filesystems */
-  am_ops *mf_ops;		/* Operations on this mountpoint */
-  am_opts *mf_fo;		/* File opts */
-  char *mf_mount;		/* "/a/kiska/home/kiska" */
-  char *mf_info;		/* Mount info */
-  char *mf_auto;		/* Automount opts */
-  char *mf_mopts;		/* FS mount opts */
-  char *mf_remopts;		/* Remote FS mount opts */
-  fserver *mf_server;		/* File server */
-  int mf_flags;			/* Flags MFF_* */
-  int mf_error;			/* Error code from background mount */
-  int mf_refc;			/* Number of references to this node */
-  int mf_cid;			/* Callout id */
-  void (*mf_prfree) (voidp);	/* Free private space */
-  voidp mf_private;		/* Private - per-fs data */
-};
-
-/*
- * File Handle
- *
- * This is interpreted by indexing the exported array
- * by fhh_id.
- *
- * The whole structure is mapped onto a standard fhandle_t
- * when transmitted.
- */
-struct am_fh {
-  int fhh_pid;			/* process id */
-  int fhh_id;			/* map id */
-  int fhh_gen;			/* generation number */
-};
-
-/*
- * Multi-protocol NFS file handle
- */
-union am_nfs_handle {
-				/* placeholder for V4 file handle */
-#ifdef HAVE_FS_NFS3
-  struct mountres3	v3;	/* NFS version 3 handle */
-#endif /* HAVE_FS_NFS3 */
-  struct fhstatus	v2;	/* NFS version 2 handle */
-};
-typedef union am_nfs_handle am_nfs_handle_t;
-
-/*
- * automounter vfs/vnode operations.
- */
-typedef char *(*vfs_match) (am_opts *);
-typedef int (*vfs_init) (mntfs *);
-typedef int (*vmount_fs) (am_node *);
-typedef int (*vfmount_fs) (mntfs *);
-typedef int (*vumount_fs) (am_node *);
-typedef int (*vfumount_fs) (mntfs *);
-typedef am_node *(*vlookuppn) (am_node *, char *, int *, int);
-typedef int (*vreaddir) (am_node *, nfscookie, nfsdirlist *, nfsentry *, int);
-typedef am_node *(*vreadlink) (am_node *, int *);
-typedef void (*vmounted) (mntfs *);
-typedef void (*vumounted) (am_node *);
-typedef fserver *(*vffserver) (mntfs *);
-
-struct am_ops {
-  char		*fs_type;	/* type of filesystems "nfsx" */
-  vfs_match	fs_match;	/* fxn: match */
-  vfs_init	fs_init;	/* fxn: initialization */
-  vmount_fs	mount_fs;	/* fxn: mount vnode */
-  vfmount_fs	fmount_fs;	/* fxn: mount VFS */
-  vumount_fs	umount_fs;	/* fxn: unmount vnode */
-  vfumount_fs	fumount_fs;	/* fxn: unmount VFS */
-  vlookuppn	lookuppn;	/* fxn: lookup path-name */
-  vreaddir	readdir;	/* fxn: read directory */
-  vreadlink	readlink;	/* fxn: read link */
-  vmounted	mounted;	/* fxn: after-mount extra actions */
-  vumounted	umounted;	/* fxn: after-umount extra actions */
-  vffserver	ffserver;	/* fxn: find a file server */
-  int		fs_flags;	/* filesystem flags FS_* */
-};
-
-typedef int (*task_fun) (voidp);
-typedef void (*cb_fun) (int, int, voidp);
-typedef void (*fwd_fun) P((voidp, int, struct sockaddr_in *,
-			   struct sockaddr_in *, voidp, int));
 
 /*
  * List of mount table entries
@@ -407,76 +223,6 @@ struct mntlist {
  */
 typedef struct mnt_map mnt_map;
 
-/*
- * Per-mountpoint statistics
- */
-struct am_stats {
-  time_t s_mtime;		/* Mount time */
-  u_short s_uid;		/* Uid of mounter */
-  int s_getattr;		/* Count of getattrs */
-  int s_lookup;			/* Count of lookups */
-  int s_readdir;		/* Count of readdirs */
-  int s_readlink;		/* Count of readlinks */
-  int s_statfs;			/* Count of statfs */
-};
-typedef struct am_stats am_stats;
-
-/*
- * System statistics
- */
-struct amd_stats {
-  int d_drops;			/* Dropped requests */
-  int d_stale;			/* Stale NFS handles */
-  int d_mok;			/* Successful mounts */
-  int d_merr;			/* Failed mounts */
-  int d_uerr;			/* Failed unmounts */
-};
-extern struct amd_stats amd_stats;
-
-/*
- * List of fileservers
- */
-struct fserver {
-  qelem fs_q;			/* List of fileservers */
-  int fs_refc;			/* Number of references to this node */
-  char *fs_host;		/* Normalized hostname of server */
-  struct sockaddr_in *fs_ip;	/* Network address of server */
-  int fs_cid;			/* Callout id */
-  int fs_pinger;		/* Ping (keepalive) interval */
-  int fs_flags;			/* Flags */
-  char *fs_type;		/* File server type */
-  u_long fs_version;		/* NFS version of server (2, 3, etc.)*/
-  char *fs_proto;		/* NFS protocol of server (tcp, udp, etc.) */
-  voidp fs_private;		/* Private data */
-  void (*fs_prfree) (voidp);	/* Free private data */
-};
-
-/*
- * Map of auto-mount points.
- */
-struct am_node {
-  int am_mapno;		/* Map number */
-  mntfs *am_mnt;	/* Mounted filesystem */
-  char *am_name;	/* "kiska": name of this node */
-  char *am_path;	/* "/home/kiska": path of this node's mount point */
-  char *am_link;	/* "/a/kiska/home/kiska/this/that": link to sub-dir */
-  am_node *am_parent;	/* Parent of this node */
-  am_node *am_ysib;	/* Younger sibling of this node */
-  am_node *am_osib;	/* Older sibling of this node */
-  am_node *am_child;	/* First child of this node */
-  nfsattrstat am_attr;	/* File attributes */
-#define am_fattr	am_attr.ns_u.ns_attr_u
-  int am_flags;		/* Boolean flags AMF_* */
-  int am_error;		/* Specific mount error */
-  time_t am_ttl;	/* Time to live */
-  int am_timeo_w;	/* Wait interval */
-  int am_timeo;		/* Timeout interval */
-  u_int am_gen;		/* Generation number */
-  char *am_pref;	/* Mount info prefix */
-  am_stats am_stats;	/* Statistics gathering */
-  SVCXPRT *am_transp;	/* Info for quick reply */
-};
-
 
 /**************************************************************************/
 /*** EXTERNALS								***/
@@ -490,8 +236,6 @@ extern char *cpu;		/* "CPU type" */
 extern char *endian;		/* "big" */
 extern char *hostdomain;	/* "southseas.nz" */
 extern char copyright[];	/* Copyright info */
-extern char hostd[];		/* "kiska.southseas.nz" */
-extern char pid_fsname[];	/* kiska.southseas.nz:(pid%d) */
 extern char version[];		/* Version info */
 
 /*
@@ -499,42 +243,26 @@ extern char version[];		/* Version info */
  */
 extern AUTH *nfs_auth;		/* Dummy authorization for remote servers */
 extern FILE *logfp;		/* Log file */
-extern am_node **exported_ap;	/* List of nodes */
-extern am_node *root_node;	/* Node for "root" */
+extern SVCXPRT *nfsxprt;
 extern char *PrimNetName;	/* Name of primary connected network */
 extern char *PrimNetNum;	/* Name of primary connected network */
 extern char *SubsNetName;	/* Name of subsidiary connected network */
 extern char *SubsNetNum;	/* Name of subsidiary connected network */
 
-#if 0
-extern char *progname;		/* "amd" */
-#endif
-extern void am_set_progname(char *pn);	/* "amd" */
-extern const char * am_get_progname(void); /* "amd" */
+extern void am_set_progname(char *pn); /* "amd" */
+extern const char *am_get_progname(void); /* "amd" */
 extern void am_set_hostname(char *hn);
-extern const char * am_get_hostname(void);
+extern const char *am_get_hostname(void);
 extern pid_t am_set_mypid(void);
 extern pid_t am_mypid;
 
-#if 0
-extern char hostname[];		/* "kiska" */
-extern pid_t mypid;		/* Current process id */
-#endif
-
-extern int first_free_map;	/* First free node */
 extern int foreground;		/* Foreground process */
-extern int immediate_abort;	/* Should close-down unmounts be retried */
-extern int last_used_map;	/* Last map being used for mounts */
 extern int orig_umask;		/* umask() on startup */
-extern int task_notify_todo;	/* Task notifier needs running */
 extern int xlog_level;		/* Logging level */
 extern int xlog_level_init;
 extern serv_state amd_state;	/* Should we go now */
 extern struct in_addr myipaddr;	/* (An) IP address of this host */
 extern struct opt_tab xlog_opt[];
-extern time_t clock_valid;	/* Clock needs recalculating */
-extern time_t do_mapc_reload;	/* Flush & reload mount map cache */
-extern time_t next_softclock;	/* Time to call softclock() */
 extern u_short nfs_port;	/* Our NFS service port */
 
 /*
@@ -542,132 +270,92 @@ extern u_short nfs_port;	/* Our NFS service port */
  */
 extern CLIENT *get_mount_client(char *unused_host, struct sockaddr_in *sin, struct timeval *tv, int *sock, u_long mnt_version);
 extern RETSIGTYPE sigchld(int);
-extern SVCXPRT *nfsxprt;
-extern am_node *efs_lookuppn(am_node *, char *, int *, int);
-extern am_node *exported_ap_alloc(void);
-extern am_node *fh_to_mp(am_nfs_fh *);
-extern am_node *fh_to_mp3(am_nfs_fh *, int *, int);
-extern am_node *find_mf(mntfs *);
-extern am_node *next_map(int *);
-extern am_node *root_ap(char *, int);
-extern am_ops *ops_match(am_opts *, char *, char *, char *, char *, char *);
 extern bool_t xdr_amq_string(XDR *xdrs, amq_string *objp);
 extern bool_t xdr_dirpath(XDR *xdrs, dirpath *objp);
 extern char **strsplit(char *, int, int);
-extern char *expand_key(char *);
+extern char *expand_selectors(char *);
 extern char *get_version_string(void);
-extern char *inet_dquad(char *, u_long);
+extern char *inet_dquad(char *, size_t, u_long);
 extern char *print_wires(void);
 extern char *str3cat(char *, char *, char *, char *);
 extern char *strealloc(char *, char *);
 extern char *strip_selectors(char *, char *);
 extern char *strnsave(const char *, int);
-extern fserver *dup_srvr(fserver *);
 extern int amu_close(int fd);
-extern int background(void);
 extern int bind_resv_port(int, u_short *);
 extern int cmdoption(char *, struct opt_tab *, int *);
 extern int compute_automounter_mount_flags(mntent_t *);
 extern int compute_mount_flags(mntent_t *);
-extern int efs_readdir(am_node *, nfscookie, nfsdirlist *, nfsentry *, int);
-extern int eval_fs_opts(am_opts *, char *, char *, char *, char *, char *);
-extern int fwd_init(void);
-extern int fwd_packet(int, voidp, int, struct sockaddr_in *, struct sockaddr_in *, voidp, fwd_fun);
 extern int get_amd_program_number(void);
+extern int getcreds(struct svc_req *, uid_t *, gid_t *, SVCXPRT *);
 extern int hasmntval(mntent_t *, char *);
+extern unsigned int hasmntvalerr(mntent_t *, char *, int *);
+extern char *hasmntstr(mntent_t *, char *);
+extern char *hasmnteq(mntent_t *, char *);
+extern char *haseq(char *);
 extern int is_network_member(const char *net);
+extern int is_interface_local(u_long);
 extern int islocalnet(u_long);
-extern int make_nfs_auth(void);
 extern int make_rpc_packet(char *, int, u_long, struct rpc_msg *, voidp, XDRPROC_T_TYPE, AUTH *);
-extern int mapc_keyiter(mnt_map *, void(*)(char *, voidp), voidp);
-extern int mapc_search(mnt_map *, char *, char **);
-extern int mapc_type_exists(const char *type);
 extern int mkdirs(char *, int);
-extern int mount_auto_node(char *, voidp);
-extern int mount_automounter(int);
-extern int mount_exported(void);
-extern int mount_fs(mntent_t *, int, caddr_t, int, MTYPE_TYPE, u_long, const char *, const char *);
-extern int mount_node(am_node *);
-extern int nfs_srvr_port(fserver *, u_short *, voidp);
+extern int mount_fs(mntent_t *, int, caddr_t, int, MTYPE_TYPE, u_long, const char *, const char *, int);
+extern void nfs_program_2(struct svc_req *rqstp, SVCXPRT *transp);
 extern int pickup_rpc_reply(voidp, int, voidp, XDRPROC_T_TYPE);
-extern int root_keyiter(void(*)(char *, voidp), voidp);
-extern int softclock(void);
 extern int switch_option(char *);
-extern int switch_to_logfile(char *logfile, int orig_umask);
-extern int timeout(u_int, void (*fn)(voidp), voidp);
-extern int valid_key(char *);
-extern mnt_map *mapc_find(char *, char *, const char *);
-extern mntfs *dup_mntfs(mntfs *);
-extern mntfs *find_mntfs(am_ops *, am_opts *, char *, char *, char *, char *, char *);
-extern mntfs *new_mntfs(void);
-extern mntfs *realloc_mntfs(mntfs *, am_ops *, am_opts *, char *, char *, char *, char *, char *);
+extern int switch_to_logfile(char *logfile, int orig_umask, int truncate_log);
 extern mntlist *read_mtab(char *, const char *);
+#ifndef HAVE_TRANSPORT_TYPE_TLI
 extern struct sockaddr_in *amu_svc_getcaller(SVCXPRT *xprt);
+#endif /* not HAVE_TRANSPORT_TYPE_TLI */
 extern time_t time(time_t *);
-extern void am_mounted(am_node *);
-extern void am_unmounted(am_node *);
-extern void amq_program_1(struct svc_req *rqstp, SVCXPRT * transp);
-extern void amu_get_myaddress(struct in_addr *iap);
+extern void amu_get_myaddress(struct in_addr *iap, const char *preferred_localhost);
 extern void amu_release_controlling_tty(void);
 extern void compute_automounter_nfs_args(nfs_args_t *nap, mntent_t *mntp);
-extern void deslashify(char *);
 extern void discard_mntlist(mntlist *mp);
-extern void do_task_notify(void);
-extern void flush_mntfs(void);
-extern void flush_nfs_fhandle_cache(fserver *);
-extern void forcibly_timeout_mp(am_node *);
-extern void free_map(am_node *);
-extern void free_mntfs(voidp);
 extern void free_mntlist(mntlist *);
-extern void free_opts(am_opts *);
-extern void free_srvr(fserver *);
-extern void fwd_reply(void);
-extern void get_args(int argc, char *argv[]);
 extern void getwire(char **name1, char **number1);
 extern void going_down(int);
-extern void host_normalize(char **);
-extern void init_map(am_node *, char *);
-extern void ins_que(qelem *, qelem *);
-extern void insert_am(am_node *, am_node *);
-extern void make_root_node(void);
-extern void map_flush_srvr(fserver *);
-extern void mapc_add_kv(mnt_map *, char *, char *);
-extern void mapc_free(voidp);
-extern void mapc_reload(void);
-extern void mapc_showtypes(char *buf);
-extern void mk_fattr(am_node *, nfsftype);
 extern void mnt_free(mntent_t *);
-extern void mp_to_fh(am_node *, am_nfs_fh *);
-extern void new_ttl(am_node *);
-extern void nfs_program_2(struct svc_req *rqstp, SVCXPRT *transp);
-extern void normalize_slash(char *);
-extern void ops_showamfstypes(char *buf);
-extern void ops_showfstypes(char *outbuf);
-extern void plog(int, char *,...)
+extern void plog(int, const char *,...)
      __attribute__ ((__format__ (__printf__, 2, 3)));
-extern void rem_que(qelem *);
-extern void reschedule_timeout_mp(void);
-extern void restart(void);
 extern void rmdirs(char *);
 extern void rpc_msg_init(struct rpc_msg *, u_long, u_long, u_long);
-extern void run_task(task_fun, voidp, cb_fun, voidp);
-extern void sched_task(cb_fun, voidp, voidp);
 extern void set_amd_program_number(int program);
 extern void show_opts(int ch, struct opt_tab *);
-extern void show_rcs_info(const char *, char *);
-extern void srvrlog(fserver *, char *);
-extern void timeout_mp(voidp);
-extern void umount_exported(void);
 extern void unregister_amq(void);
-extern void untimeout(int);
-extern void wakeup(voidp);
-extern void wakeup_srvr(fserver *);
-extern void wakeup_task(int, int, voidp);
 extern voidp xmalloc(int);
 extern voidp xrealloc(voidp, int);
 extern voidp xzalloc(int);
+extern int check_pmap_up(char *host, struct sockaddr_in* sin);
 extern u_long get_nfs_version(char *host, struct sockaddr_in *sin, u_long nfs_version, const char *proto);
+extern long get_server_pid(void);
+extern void setup_sighandler(int signum, void (*handler)(int));
+extern time_t clocktime(nfstime *nt);
+
+#if defined(DEBUG) && (defined(HAVE_C99_VARARGS_MACROS) || defined(HAVE_GCC_VARARGS_MACROS))
+# ifdef HAVE_C99_VARARGS_MACROS
+#define xsnprintf(str,size,fmt,...)	_xsnprintf(__FILE__,__LINE__,(str),(size),(fmt),__VA_ARGS__)
+# endif /* HAVE_C99_VARARGS_MACROS */
+# ifdef HAVE_GCC_VARARGS_MACROS
+#define xsnprintf(str,size,fmt,args...)		_xsnprintf(__FILE__,__LINE__,(str),(size),(fmt),args)
+# endif /* HAVE_GCC_VARARGS_MACROS */
+extern int _xsnprintf(const char *filename, int lineno, char *str, size_t size, const char *format, ...);
+#define xvsnprintf(str,size,fmt,ap)	_xvsnprintf(__FILE__,__LINE__,(str),(size),(fmt),(ap))
+extern int _xvsnprintf(const char *filename, int lineno, char *str, size_t size, const char *format, va_list ap);
+#else /* not DEBUG or no C99/GCC-style vararg cpp macros supported */
+extern int xsnprintf(char *str, size_t size, const char *format, ...);
+extern int xvsnprintf(char *str, size_t size, const char *format, va_list ap);
+#endif /* not DEBUG or no C99/GCC-style vararg cpp macros supported */
 
+#ifdef DEBUG
+extern void _xstrlcat(const char *filename, int lineno, char *dst, const char *src, size_t len);
+# define xstrlcat(d,s,l)	_xstrlcat(__FILE__,__LINE__,(d),(s),(l))
+extern void _xstrlcpy(const char *filename, int lineno, char *dst, const char *src, size_t len);
+# define xstrlcpy(d,s,l)	_xstrlcpy(__FILE__,__LINE__,(d),(s),(l))
+#else /* not DEBUG */
+extern void xstrlcat(char *dst, const char *src, size_t len);
+extern void xstrlcpy(char *dst, const char *src, size_t len);
+#endif /* not DEBUG */
 
 #ifdef MOUNT_TABLE_ON_FILE
 extern void rewrite_mtab(mntlist *, const char *);
@@ -679,81 +367,28 @@ extern void write_mntent(mntent_t *, const char *);
 extern int syslogging;
 #endif /* defined(HAVE_SYSLOG_H) || defined(HAVE_SYS_SYSLOG_H) */
 
-#ifdef HAVE_TRANSPORT_TYPE_TLI
-
 extern void compute_nfs_args(nfs_args_t *nap, mntent_t *mntp, int genflags, struct netconfig *nfsncp, struct sockaddr_in *ip_addr, u_long nfs_version, char *nfs_proto, am_nfs_handle_t *fhp, char *host_name, char *fs_name);
-extern int create_amq_service(int *udp_soAMQp, SVCXPRT **udp_amqpp, struct netconfig **udp_amqncpp, int *tcp_soAMQp, SVCXPRT **tcp_amqpp, struct netconfig **tcp_amqncpp);
+extern int create_amq_service(int *udp_soAMQp, SVCXPRT **udp_amqpp, struct netconfig **udp_amqncpp, int *tcp_soAMQp, SVCXPRT **tcp_amqpp, struct netconfig **tcp_amqncpp, u_short preferred_amq_port);
 extern int create_nfs_service(int *soNFSp, u_short *nfs_portp, SVCXPRT **nfs_xprtp, void (*dispatch_fxn)(struct svc_req *rqstp, SVCXPRT *transp));
+extern int amu_svc_register(SVCXPRT *, u_long, u_long, void (*)(struct svc_req *, SVCXPRT *), u_long, struct netconfig *);
+
+#ifdef HAVE_TRANSPORT_TYPE_TLI
+
 extern int get_knetconfig(struct knetconfig **kncpp, struct netconfig *in_ncp, char *nc_protoname);
 extern struct netconfig *nfsncp;
 extern void free_knetconfig(struct knetconfig *kncp);
 
-#else /* not HAVE_TRANSPORT_TYPE_TLI */
+#endif /* HAVE_TRANSPORT_TYPE_TLI */
 
-extern void compute_nfs_args(nfs_args_t *nap, mntent_t *mntp, int genflags, struct sockaddr_in *ip_addr, u_long nfs_version, char *nfs_proto, am_nfs_handle_t *fhp, char *host_name, char *fs_name);
-extern enum clnt_stat pmap_ping(struct sockaddr_in *address);
-extern int create_amq_service(int *udp_soAMQp, SVCXPRT **udp_amqpp, int *tcp_soAMQp, SVCXPRT **tcp_amqpp);
-extern int create_nfs_service(int *soNFSp, u_short *nfs_portp, SVCXPRT **nfs_xprtp, void (*dispatch_fxn)(struct svc_req *rqstp, SVCXPRT *transp));
+#ifdef HAVE_FS_AUTOFS
+extern int register_autofs_service(char *autofs_conftype, void (*autofs_dispatch)(struct svc_req *rqstp, SVCXPRT *xprt));
+extern int unregister_autofs_service(char *autofs_conftype);
+#endif /* HAVE_FS_AUTOFS */
 
-#endif /* not HAVE_TRANSPORT_TYPE_TLI */
 
-#ifndef HAVE_FIELD_STRUCT_FHSTATUS_FHS_FH
+#ifndef HAVE_STRUCT_FHSTATUS_FHS_FH
 # define fhs_fh  fhstatus_u.fhs_fhandle
-#endif /* not HAVE_FIELD_STRUCT_FHSTATUS_FHS_FH */
-
-
-/**************************************************************************/
-/*** Generic file-system types, implemented as part of the native O/S.	***/
-/**************************************************************************/
-
-/*
- * Loopback File System
- * Many systems can't support this, and in any case most of the
- * functionality is available with Symlink FS.
- */
-#ifdef HAVE_FS_LOFS
-extern am_ops lofs_ops;
-#endif /* HAVE_FS_LOFS */
-
-/*
- * CD-ROM File System (CD-ROM)
- * (HSFS: High Sierra F/S on some machines)
- * Many systems can't support this, and in any case most of the
- * functionality is available with program FS.
- */
-#ifdef HAVE_FS_CDFS
-extern am_ops cdfs_ops;
-#endif /* HAVE_FS_CDFS */
-
-/*
- * PC File System (MS-DOS)
- * Many systems can't support this, and in any case most of the
- * functionality is available with program FS.
- */
-#ifdef HAVE_FS_PCFS
-extern am_ops pcfs_ops;
-#endif /* HAVE_FS_PCFS */
-
-/*
- * Caching File System (Solaris)
- */
-#ifdef HAVE_FS_CACHEFS
-extern am_ops cachefs_ops;
-#endif /* HAVE_FS_CACHEFS */
-
-/*
- * Network File System
- * Good, slow, NFS V.2.
- */
-#ifdef HAVE_FS_NFS
-extern am_ops nfs_ops;		/* NFS */
-extern fserver *find_nfs_srvr (mntfs *);
-extern int nfs_fmount(mntfs *mf);
-extern int nfs_fumount(mntfs *mf);
-extern int nfs_init(mntfs *mf);
-extern qelem nfs_srvr_list;
-extern void nfs_umounted(am_node *mp);
-#endif /* HAVE_FS_NFS */
+#endif /* not HAVE_STRUCT_FHSTATUS_FHS_FH */
 
 
 /*
